if AleaUI_GUI then return end
local C = _G['AleaGUI_PrototypeLib']

C.colorFrames = {}

local current

local customColorPicker = _G['AleaUIGUI-ColorPickerFrame'] or CreateFrame('Frame', 'AleaUIGUI-ColorPickerFrame', UIParent)
customColorPicker:SetSize(300, 200)
customColorPicker:SetPoint("CENTER")
customColorPicker:SetBackdrop({
	bgFile = [[Interface\Buttons\WHITE8x8]],
	edgeFile = [[Interface\DialogFrame\UI-DialogBox-Border]],
	edgeSize = 16,
	insets = {
		left = 5,
		right = 5,
		top = 5,
		bottom = 5,
	}
})
customColorPicker:SetBackdropColor(0, 0, 0, 0.7)
customColorPicker:SetBackdropBorderColor(1, 1, 1, 1)
customColorPicker:Hide()

local dimension = 96
local withalpha = true
local alphawidth = 18
local colorselect = CreateFrame("ColorSelect", customColorPicker:GetName()..'ColorSelect', customColorPicker)
colorselect:SetPoint("TOPLEFT", customColorPicker, "TOPLEFT", 10, -10)
colorselect:SetFrameLevel(customColorPicker:GetFrameLevel() + 10)
colorselect:SetWidth((dimension or 128)+37)
colorselect:SetHeight(dimension or 128)

local colorwheel = colorselect:CreateTexture()
colorwheel:SetWidth(dimension or 128)
colorwheel:SetHeight(dimension or 128)
colorwheel:SetPoint("TOPLEFT", colorselect, "TOPLEFT", 5, 0)
colorselect:SetColorWheelTexture(colorwheel)

local colorwheelthumbtexture = colorselect:CreateTexture()
colorwheelthumbtexture:SetTexture("Interface\\Buttons\\UI-ColorPicker-Buttons")
colorwheelthumbtexture:SetWidth(10)
colorwheelthumbtexture:SetHeight(10)
colorwheelthumbtexture:SetTexCoord(0,0.15625, 0, 0.625)
colorselect:SetColorWheelThumbTexture(colorwheelthumbtexture)

local colorvalue = colorselect:CreateTexture()
colorvalue:SetWidth(alphawidth or 32)
colorvalue:SetHeight(dimension or 128)
colorvalue:SetPoint("LEFT", colorwheel, "RIGHT", 10, -3)
colorselect:SetColorValueTexture(colorvalue)
local colorvaluethumbtexture = colorselect:CreateTexture()
colorvaluethumbtexture:SetTexture("Interface\\Buttons\\UI-ColorPicker-Buttons")
colorvaluethumbtexture:SetWidth( alphawidth/32 * 48)
colorvaluethumbtexture:SetHeight( alphawidth/32 * 14)
colorvaluethumbtexture:SetTexCoord(0.25, 1, 0.875, 0)
colorselect:SetColorValueThumbTexture(colorvaluethumbtexture)

local cancelbutton = CreateFrame('Button', nil, customColorPicker, "UIPanelButtonTemplate")
cancelbutton:SetPoint("BOTTOMRIGHT", customColorPicker, "BOTTOMRIGHT", -3, 6)
cancelbutton:SetSize(80, 22)
cancelbutton:SetText(CANCEL)

local okeybutton = CreateFrame('Button', nil, customColorPicker, "UIPanelButtonTemplate")
okeybutton:SetPoint("RIGHT", cancelbutton, "LEFT", -2, 0)
okeybutton:SetSize(80, 22)
okeybutton:SetText(ACCEPT)	
okeybutton:SetScript('OnClick', function()

	print("T",'Red', select(1, self:GetColorRGB()))
	print("T",'Green', select(2, self:GetColorRGB()))
	print("T",'Blue', select(3, self:GetColorRGB()))
	
end)

local editBoxR255 = CreateFrame("EditBox", nil, customColorPicker, "InputBoxTemplate")
editBoxR255:SetFontObject(ChatFontNormal)
editBoxR255:SetFrameLevel(customColorPicker:GetFrameLevel() + 1)
editBoxR255:SetAutoFocus(false)
editBoxR255:SetNumeric(true)
editBoxR255:SetWidth(40)
editBoxR255:SetHeight(20)
editBoxR255:SetPoint('TOPRIGHT', customColorPicker, 'TOPRIGHT', -10, -20)
editBoxR255:SetScript("OnEnterPressed", function(self)
	local r = tonumber(self:GetText())/255
	local _, g, b = colorselect:GetColorRGB()
	colorselect:SetColorRGB(r,g,b)
end)

local editBoxG255 = CreateFrame("EditBox", nil, customColorPicker, "InputBoxTemplate")
editBoxG255:SetFontObject(ChatFontNormal)
editBoxG255:SetFrameLevel(customColorPicker:GetFrameLevel() + 1)
editBoxG255:SetAutoFocus(false)
editBoxG255:SetNumeric(true)
editBoxG255:SetWidth(40)
editBoxG255:SetHeight(20)
editBoxG255:SetPoint('TOP', editBoxR255, 'BOTTOM', 0, -3)
editBoxG255:SetScript("OnEnterPressed", function(self)
	local g = tonumber(self:GetText())/255
	local r, _, b = colorselect:GetColorRGB()
	colorselect:SetColorRGB(r,g,b)
end)

local editBoxB255 = CreateFrame("EditBox", nil, customColorPicker, "InputBoxTemplate")
editBoxB255:SetFontObject(ChatFontNormal)
editBoxB255:SetFrameLevel(customColorPicker:GetFrameLevel() + 1)
editBoxB255:SetAutoFocus(false)
editBoxB255:SetNumeric(true)
editBoxB255:SetWidth(40)
editBoxB255:SetHeight(20)
editBoxB255:SetPoint('TOP', editBoxG255, 'BOTTOM', 0, -3)
editBoxB255:SetScript("OnEnterPressed", function(self)
	local b = tonumber(self:GetText())/255
	local r, g, _ = colorselect:GetColorRGB()
	colorselect:SetColorRGB(r,g,b)
end)


customColorPicker.editBoxR255 = editBoxR255
customColorPicker.editBoxG255 = editBoxG255
customColorPicker.editBoxB255 = editBoxB255

local editBoxR1 = CreateFrame("EditBox", nil, customColorPicker, "InputBoxTemplate")
editBoxR1:SetFontObject(ChatFontNormal)
editBoxR1:SetFrameLevel(customColorPicker:GetFrameLevel() + 1)
editBoxR1:SetAutoFocus(false)
editBoxR1:SetWidth(40)
editBoxR1:SetHeight(20)
editBoxR1:SetPoint('TOPRIGHT', customColorPicker, 'TOPRIGHT', -60, -20)
editBoxR1:SetScript("OnEnterPressed", function(self)
	local r = tonumber(self:GetText())
	local _, g, b = colorselect:GetColorRGB()
	colorselect:SetColorRGB(r,g,b)
end)

local editBoxG1 = CreateFrame("EditBox", nil, customColorPicker, "InputBoxTemplate")
editBoxG1:SetFontObject(ChatFontNormal)
editBoxG1:SetFrameLevel(customColorPicker:GetFrameLevel() + 1)
editBoxG1:SetAutoFocus(false)
editBoxG1:SetWidth(40)
editBoxG1:SetHeight(20)
editBoxG1:SetPoint('TOP', editBoxR1, 'BOTTOM', 0, -3)
editBoxG1:SetScript("OnEnterPressed", function(self)
	local g = tonumber(self:GetText())
	local r, _, b = colorselect:GetColorRGB()
	colorselect:SetColorRGB(r,g,b)
end)

local editBoxB1 = CreateFrame("EditBox", nil, customColorPicker, "InputBoxTemplate")
editBoxB1:SetFontObject(ChatFontNormal)
editBoxB1:SetFrameLevel(customColorPicker:GetFrameLevel() + 1)
editBoxB1:SetAutoFocus(false)
editBoxB1:SetWidth(40)
editBoxB1:SetHeight(20)
editBoxB1:SetPoint('TOP', editBoxG1, 'BOTTOM', 0, -3)
editBoxB1:SetScript("OnEnterPressed", function(self)
	local b = tonumber(self:GetText())
	local r, g, _ = colorselect:GetColorRGB()
	colorselect:SetColorRGB(r,g,b)
end)

customColorPicker.editBoxR1 = editBoxR1
customColorPicker.editBoxG1 = editBoxG1
customColorPicker.editBoxB1 = editBoxB1

local editBoxHex = CreateFrame("EditBox", nil, customColorPicker, "InputBoxTemplate")
editBoxHex:SetFontObject(ChatFontNormal)
editBoxHex:SetFrameLevel(customColorPicker:GetFrameLevel() + 1)
editBoxHex:SetAutoFocus(false)
editBoxHex:SetWidth(60)
editBoxHex:SetHeight(20)
editBoxHex:SetPoint('TOPLEFT', editBoxB1, 'BOTTOMLEFT', 0, -3)
editBoxHex:SetScript("OnEnterPressed", function(self)
	
end)

colorselect:SetScript("OnColorSelect", function(self)

	local r, g, b = self:GetColorRGB()

	local t1 = self:GetColorWheelThumbTexture()
	local t2 = self:GetColorWheelTexture()
	local t12 = t1:GetBottom()
	local t22 = t2:GetBottom()
	
--	print("T", t12, t22)
	
	editBoxR1:SetText(tonumber(format('%.2f',r)))
	editBoxG1:SetText(tonumber(format('%.2f',g)))
	editBoxB1:SetText(tonumber(format('%.2f',b)))
	
	editBoxR255:SetText(tonumber(format('%.0f',r*255)))
	editBoxG255:SetText(tonumber(format('%.0f',g*255)))
	editBoxB255:SetText(tonumber(format('%.0f',b*255)))
	
	editBoxHex:SetText(format("ff%02x%02x%02x", r*255, g*255, b*255))
end)


local function ShowColorPicker(r,g,b,a,showalpha)
	
	colorselect:SetColorRGB(r,g,b)
	
	editBoxR1:SetText(tonumber(format('%.2f',r)))
	editBoxG1:SetText(tonumber(format('%.2f',g)))
	editBoxB1:SetText(tonumber(format('%.2f',b)))
	
	editBoxR255:SetText(tonumber(format('%.0f',r*255)))
	editBoxG255:SetText(tonumber(format('%.0f',g*255)))
	editBoxB255:SetText(tonumber(format('%.0f',b*255)))
end

local function func_1(restore)
	local newR, newG, newB, newA;
	if restore then
		newR, newG, newB, newA = unpack(restore);
	else	
		newA, newR, newG, newB = OpacitySliderFrame:GetValue(), ColorPickerFrame:GetColorRGB();
	end
	
	current._OnClick(_, newR, newG, newB,newA)
	current:SetBackdropColor(newR, newG, newB,newA or 1) -- 
	
	C:GetRealParent(current):RefreshData()
end


local function ShowColorPicker(r, g, b, a, hasalpha, f)
 
 current = f
 
 ColorPickerFrame:SetColorRGB(r,g,b);

 ColorPickerFrame.hasOpacity = hasalpha
 
 ColorPickerFrame.opacity = a;
 
 ColorPickerFrame.previousValues = {r,g,b,a};
 
 ColorPickerFrame.func = func_1
 ColorPickerFrame.opacityFunc = func_1
 ColorPickerFrame.cancelFunc = func_1

 ColorPickerFrame:Hide(); -- Need to run the OnShow handler.
 ColorPickerFrame:Show();
end


local colorpicker = CreateFrame("Frame", nil, UIParent)
colorpicker:SetSize(300, 200)
colorpicker:SetPoint("CENTER")




local function Update(self, panel, opts)
	
	self.free = false
	self:SetParent(panel)
	self:Show()	
	
	self:SetDescription(opts.desc)
	self:SetName(opts.name)
	
	self:UpdateColor(opts)
	self:UpdateState(opts.set, opts.get)
end

local function Remove(self)
	self.free = true
	self:Hide()	
end

local function SetName(self, name)
	self.main._rname = name
	self.main.text:SetText(name)
end

local function SetDescription(self, text)
	self.main.desc = text
end

local function UpdateState(self, func, get)
	
	self.main._OnClick = func
	self.main._OnShow = get

end

local function UpdateColor(self, opts)

	self.main.hasAlpha = opts.hasAlpha
	
	local r,g,b,a = opts.get()
	
	self.main.texture:SetTexture(r,g,b, self.main.hasAlpha and ( a or 1 ) or 1)

end

local function CreateCoreButton(parent)
	local f = CreateFrame('Button', nil, parent) --"UICheckButtonTemplate"

	f:SetFrameLevel(parent:GetFrameLevel() + 1)
	f:SetSize(21, 21)

	local colorSwatch = f:CreateTexture(nil, "OVERLAY")
	colorSwatch:SetWidth(16)
	colorSwatch:SetHeight(16)
	colorSwatch:SetTexture("Interface\\ChatFrame\\ChatFrameColorSwatch")
	colorSwatch:SetPoint("CENTER")

	local texture = f:CreateTexture(nil, "BACKGROUND", 0)
	texture:SetWidth(13)
	texture:SetHeight(13)
	texture:SetTexture(1, 1, 1)
	texture:SetPoint("CENTER", colorSwatch)
	texture:Show()
	
	local checkers = f:CreateTexture(nil, "BACKGROUND", -1)
	checkers:SetWidth(11)
	checkers:SetHeight(11)
	checkers:SetTexture("Tileset\\Generic\\Checkers")
	checkers:SetTexCoord(.25, 0, 0.5, .25)
--	checkers:SetDesaturated(true)
	checkers:SetVertexColor(1, 1, 1, 0.75)
	checkers:SetPoint("CENTER", colorSwatch)
	checkers:Show()
	
	f:SetBackdrop({
		bgFile = "",
		edgeFile = [=[Interface\ChatFrame\ChatFrameBackground]=], 
		edgeSize = 2,
		insets = {top = 0, left = 0, bottom = 0, right = 0},
		})
	f:SetBackdropBorderColor(unpack(C.button_border_color_ondown)) -- 
	
	f:SetScript("OnEnter", function(self)
		self:SetBackdropBorderColor(unpack(C.button_border_color_onup)) -- 		
		C.Tooltip(self, self._rname, self.desc, "show")
	end)
	f:SetScript("OnLeave", function(self)
		self:SetBackdropBorderColor(unpack(C.button_border_color_ondown)) -- 
		C.Tooltip(self, self._rname, self.desc, "hide")
	end)
	
	
	f:SetScript("OnClick", function(self)
		local r,g,b,a = self._OnShow()	
		if self.hasAlpha then
			ShowColorPicker(r,g,b,(a or 1), self.hasAlpha, self)
		else
			ShowColorPicker(r,g,b,1, self.hasAlpha, self)
		end
	end)

	local text = f:CreateFontString(nil, 'OVERLAY', "GameFontHighlight")
	text:SetPoint("LEFT", f, "RIGHT", 3 , 0)
--	text:SetFont(STANDARD_TEXT_FONT, 12, "OUTLINE")
	text:SetTextColor(1, 1, 1)
	text:SetJustifyH("LEFT")
	text:SetWordWrap(false)
	
	f.mouseover = CreateFrame("Frame", nil, f)
	f.mouseover:SetFrameLevel(f:GetFrameLevel()-1)
	f.mouseover:SetSize(1,1)
	f.mouseover:SetPoint("TOPLEFT", text, "TOPLEFT", -3, 3)
	f.mouseover:SetPoint("BOTTOMRIGHT", text, "BOTTOMRIGHT", 3, -3)
	f.mouseover:SetScript("OnEnter", function(self)
--		self:GetParent():SetBackdropBorderColor(unpack(C.button_border_color_onup)) -- 		
		C.Tooltip(self, self:GetParent()._rname, self:GetParent().desc, "show")
	end)
	f.mouseover:SetScript("OnLeave", function(self)
--		self:GetParent():SetBackdropBorderColor(unpack(C.button_border_color_ondown)) -- 
	
		C.Tooltip(self, self:GetParent()._rname, self:GetParent().desc, "hide")
	end)
	
	f.text = text
	f.texture = colorSwatch
	
	return f
end

function C:CreateColorFrame()
	
	for i=1, #C.colorFrames do
		if C.colorFrames[i].free then
			return C.colorFrames[i]
		end
	end
	
	local f = CreateFrame("Frame", nil, UIParent)
	f:SetSize(180, 45)
	f.free = true
	
	f.main = CreateCoreButton(f)
	f.main:SetPoint("TOPLEFT", f, "TOPLEFT", 5, -15)
	--[[
	local bg = f:CreateTexture()
	bg:SetAllPoints()
	bg:SetTexture(0.5, 1, 0.5, 1)
	]]
	f.Update = Update
	f.Remove = Remove
	f.SetName = SetName
	f.UpdateState = UpdateState
	f.SetDescription = SetDescription
	f.UpdateColor = UpdateColor
	
	C.colorFrames[#C.colorFrames+1] = f
	
	return f
end
	
C.prototypes["color"] = "CreateColorFrame"